;32bit (24bpp) bitmap to 4,6,16bpp converter
;return with all register modified.
[bits 32]

;ecx=count, ebx=[errorFromUp], esi=[source](32bit), edi=[dest](16bit)
;eax,ecx,edx=work, ebp=errorFromLeft

section .text	;globalsectionޤ礦

global _to16
global _to6
global _to4
global _to3
global _gosakaku16
global _gosakaku6
global _gosakaku4
global _gosakaku3

	struc forC
.savedReg:	resd 4
.retEIP:	resd 1
.delta:		resd 1	;ηۤ
.deltabuffer:	resd 1	;Хåե, (ȤwidthĤ32bit pixel)
.width:		resd 1
.source:	resd 1
.destination:	resd 1
	endstruc

_gosakaku16:
	push edi
	push esi
	push ebp
	push ebx
	mov ecx, [esp+forC.width]
	mov ebx, [esp+forC.deltabuffer]
	mov ebp, [esp+forC.delta]
	mov esi, [esp+forC.source]
	mov edi, [esp+forC.destination]
	call _to16
	pop ebx
	pop ebp
	pop esi
	pop edi
	ret

_gosakaku6:
	push edi
	push esi
	push ebp
	push ebx
	mov ecx, [esp+forC.width]
	mov ebx, [esp+forC.deltabuffer]
	mov ebp, [esp+forC.delta]
	mov esi, [esp+forC.source]
	mov edi, [esp+forC.destination]
	call _to6
	pop ebx
	pop ebp
	pop esi
	pop edi
	ret

_gosakaku4:
	push edi
	push esi
	push ebp
	push ebx
	mov ecx, [esp+forC.width]
	mov ebx, [esp+forC.deltabuffer]
	mov ebp, [esp+forC.delta]
	mov esi, [esp+forC.source]
	mov edi, [esp+forC.destination]
	call _to4
	pop ebx
	pop ebp
	pop esi
	pop edi
	ret

_gosakaku3:
	push edi
	push esi
	push ebp
	push ebx
	mov ecx, [esp+forC.width]
	mov ebx, [esp+forC.deltabuffer]
	mov ebp, [esp+forC.delta]
	mov esi, [esp+forC.source]
	mov edi, [esp+forC.destination]
	call _to3
	pop ebx
	pop ebp
	pop esi
	pop edi
	ret

_to16:	push ecx
.l:	mov eax, [esi]
	add esi, byte 4
	mov edx, 0x0000ff00	;Green
	and edx, eax
	add ebp, [ebx]		;error buffer
	and eax, 0x00ff00ff	;Red, Blue
	add edx, ebp
	add eax, ebp
	and eax, 0x01ff01ff	;ȸ׵ᤵR,B
	and edx, 0x0001ff00	;G
	push eax
	push edx

	mov ecx, eax		;ϸͭ
	mov ebp, edx
	shl eax, 5
	shl edx, 6
	sub eax, ecx
	sub edx, ebp
	shr eax, 5
	and edx, 0x0000fc00<<6	;edx=Green 
	shr edx, 6
	and eax, 0x00f800f8	;eax=Red,Blue 
	mov ecx, eax
	mov ebp, edx
	shr ecx, 5
	and ebp, 0x0000c000
	shr ebp, 6
	and ecx, 0x00070007
	or ecx, eax		;ͤФƼºݤɽ뿧ͽ
	or ebp, edx
	;
	shr eax, 3		;eax=000rrrrr-00000000-000bbbbb
	or  edx, eax		;edx=000rrrrr-gggggg00-000bbbbb
	shr edx, 5		;edx=00000000-rrrrrggg-ggg00000
	or eax, edx		;eax=00000000-rrrrrggg-gggbbbbb
	mov [edi], ax
	add edi, byte 2

	pop edx			;η׻
	pop eax
	sub eax, ecx
	sub edx, ebp
	mov ebp, 0x0000fc00
	and eax, 0x00fc00fc
	and ebp, edx
	or  ebp, eax
	shr ebp, 1
	mov [ebx], ebp
	add ebx, byte 4

	dec dword[esp]
	jnz .l
	pop ecx
	ret


;ecx=count, ebx=[errorFromUp], esi=[source](32bit), edi=[dest](6bit)
;eax,ecx,edx=work, ebp=errorFromLeft
_to6:	push ecx
.l:	mov eax, [esi]
	add esi, byte 4
	add ebp, [ebx]		;error buffer
	and eax, 0x00fefefe	;7bit٤ǲ
	add eax, ebp		;0000000r-rrrrrrrg-gggggggb-bbbbbbbb
	push eax

	and eax, 0x01f9f9ff	;00000001-11111101-11111101-11111111
	lea eax, [eax*3]	;000000rr-rrrrrrgg-ggggggbb-bbbbbbbb
	and eax, 0x03030300	;000000rr-000000gg-000000bb-00000000
	mov ebp, eax		;
	shr eax, 4		;00000000-00rr0000-00gg0000-00bb0000
	or  ebp, eax		;000000rr-00rr00gg-00gg00bb-00bb0000
	mov edx, eax		;
	shr eax, 10		;00000000-00000000-0000rr00-0000gg00
	lea ebp, [ebp*5]	;0000rrrr-rrrrgggg-ggggbbbb-bbbb0000
	or  edx, eax		;00000000-00rr0000-00ggrr00-00bbgg00
	shr ebp, 4		;00000000-rrrrrrrr-gggggggg-bbbbbbbb
	shr eax, 10		;00000000-00000000-00000000-000000rr
	or  edx, byte -0x40	;11111111-11111111-11111111-11bbgg00
	or  eax, edx		;11111111-11111111-11111111-11bbggrr
	mov [edi], al
	inc edi

	pop eax
	and ebp, 0x00fefefe
	sub eax, ebp
	shr eax, 1		;ĤʬΤȾʬ
	mov ebp, 0x007e7e7e	;ƥ˥֥LSBϲ̤η夲ͽ
	and ebp, eax
	mov [ebx], ebp
	add ebx, byte 4

	dec dword[esp]
	jnz .l
	pop ecx
	ret

; 0  8  f  17
; 0 0 r r R R
; 0 0 r r R R
; g g y y ? ?
; g g y y ? ?
; G G ? ? Y Y
; G G ? ? Y Y
; ?ʬɤ뤫? ȤꤢŤƤ?
; GR y (㵱) Υᤤ鹥ޤ?
; , ٥ȥθʤΤǱ䡹yϤĤŤ롣ޤ
;ecx=count, ebx=[errorFromUp], esi=[source](32bit), edi=[dest](4bit)
;eax,ecx,edx=work, ebp=errorFromLeft
_to4:	push ecx
.l:	mov eax, [esi]
	add esi, byte 4
	add ebp, [ebx]		;error buffer
	and eax, 0x00fefefe
	add eax, ebp		;0000000r-rrrrrrrg-gggggggb-bbbbbbbb
	push eax

	and eax, 0x01818180	;0000000r-r000000g-g000000b-b0000000
	mov ecx, 0x01010100	;00000001-00000001-00000001-00000000
	xor edx, edx
	and ecx, eax		;0000000r-0000000g-0000000b-00000000
	mov ebp, eax		;0000000r-r000000g-g000000b-b0000000
	jz .low			;⵱
	  shr eax, 1		;00000000-r?000000-g?000000-b?000000
	  mov ebp, ecx		;0000000r-0000000g-0000000b-00000000
	  inc edx		;0000000i
	.low:
	shr ecx, 7		;00000000-000000r0-000000g0-000000b0
	sub ebp, ecx		;00000000-rrrrrrr0-ggggggg0-bbbbbbb0
	shr eax, 8		;00000000-00000000-r?000000-g?000000->b
	adc dl, dl		;000000ib
	shr eax, 8		;00000000-00000000-00000000-r?000000->g
	adc dl, dl		;00000ibg
	shr eax, 8		;00000000-00000000-00000000-00000000->r
	adc dl, dl		;0000ibgr
	mov [edi], dl
	inc edi

	pop eax
	and ebp, 0x00fefefe
	sub eax, ebp
	shr eax, 1		;ĤʬΤȾʬ
	mov ebp, 0x00787878	;ƥ˥֥LSBϲ̤η夲ͽ
	and ebp, eax		;ȯɤ٤Ȥ
	mov [ebx], ebp
	add ebx, byte 4

	dec dword[esp]
	jnz .l
	pop ecx
	ret

;ecx=count, ebx=[errorFromUp], esi=[source](32bit), edi=[dest](4bit)
;eax,ecx,edx=work, ebp=errorFromLeft
_to3:	push ecx
.l:	mov eax, [esi]
	add esi, byte 4
	add ebp, [ebx]		;error buffer
	and eax, 0x00fefefe
	add eax, ebp		;0000000r-rrrrrrrg-gggggggb-bbbbbbbb
	push eax

	and eax, 0x01010100	;0000000r-0000000g-0000000b-00000000
	xor edx, edx
	mov ecx, eax		;0000000r-0000000g-0000000b-00000000
	mov ebp, eax		;0000000r-0000000g-0000000b-00000000
	shr ecx, 7		;00000000-000000r0-000000g0-000000b0
	cmp eax, byte 1
	sbb edx, byte -1	;edx+=(eax)?1:0;
	sub ebp, ecx		;00000000-rrrrrr00-gggggg00-bbbbbb00
	shr eax, 9		;00000000-00000000-r?000000-g?000000->b
	adc dl, dl		;000000ib
	shr eax, 8		;00000000-00000000-00000000-r?000000->g
	adc dl, dl		;00000ibg
	shr eax, 8		;00000000-00000000-00000000-00000000->r
	adc dl, dl		;0000ibgr
	mov [edi], dl
	inc edi

	pop eax
	and ebp, 0x00fefefe
	sub eax, ebp
	shr eax, 1		;ĤʬΤȾʬ
	mov ebp, 0x007c7c7c	;ƥ˥֥LSBϲ̤η夲ͽ
	and ebp, eax		;ȯɤ٤Ȥ
	mov [ebx], ebp
	add ebx, byte 4

	dec dword[esp]
	jnz .l
	pop ecx
	ret
