; BMP decode routine by I.Tak. 2003, 2004
;Ȼ˼δ
;ʬŸݤδ, 2004.09.11 debugged
[bits 32]

section .text
extern _to3
extern _to4
extern _to6
extern _to16

section .text align=1
;BMP File Structure (I can't understand MS.)

	struc BMP
		;FILE HEADER
.fType:		resw 1	;BM
.fSize:		resd 1	;whole file size
		resd 1	;reserved
.fOffBits:	resd 1	;offset from file top to image
		;INFO HEADER
.iSize:		resd 1	;INFO HEADER size
.iWidth:	resd 1	;Image Width in pixels
.iHeight:	resd 1	;Image Height in pixels
.iPlanes:	resw 1	;must be 1
.iBitCount:	resw 1	;BitPerPixel 1, 4, 8, 24 (and 15,16 for new OS/2 ?)
.iCompression:	resd 1	;Compress Type. 0 for none, then SizeImage=0
.iSizeImage:	resd 1	;Image Size(compressed)
.iXPPM:		resd 1	;X Pixel Per Meter
.iYPPM:		resd 1
.iClrUsed:	resd 1	;Number of used ColorQuad (0 for whole Quad)
.iClrImportant:	resd 1	;Number of Important ColorQuad.
.mask:			;R,G,B masks
	endstruc

	struc BMPOS2
		;FILE HEADER
.fType:		resw 1	;BM
.fSize:		resd 1	;whole file size
		resd 1	;reserved
.fOffBits:	resd 1	;offset from file top to image
		;CORE HEADER
.iSize:		resd 1	;CORE HEADER size
.iWidth:	resw 1	;Image Width in pixels
.iHeight:	resw 1	;Image Height in pixels
.iPlanes:	resw 1	;must be 1
.iBitCount:	resw 1	;BitPerPixel 1, 4, 8, 24 (and 15,16 for new OS/2 ?)
	endstruc

; B/W bmp can also have palettes. The first for 0, second for 1.

	struc CQuad
.b:	resb 1
.g:	resb 1
.r:	resb 1
	resb 1	;reserved
	endstruc


%if 0
int info_BMP(struct DLL_STRPICENV *env, int *info, int size, UCHAR *fp);
/* 1 (0?), Ԥ0 */
int decode0_BMP(struct DLL_STRPICENV *env, int size, UCHAR *fp,
                int b_type, UCHAR *buf, int skip);
/* 顼ɤ֤Ȥꤢ0ˤƤ */
int decode0_BMPpart(struct DLL_STRPICENV *env,int xsz,int ysz,int x,int y,int size,UCHAR*fp,int btype,UCHAR*buf,int skip);
env64KBΥꥢǤ롣Ƭ8dw֤ѤˤʤäƤ롣
ȯ餷, 󥹥ŪˤϻȤʤ褦JPEG_init
base_imgΤdecodeΤȤǤȻפ
%endif

[absolute 0]	;naskʤ[section .bss] org 0  win32ᤫ
bmpinfo:
.regs:		resd 4
.reteip:	resd 1
.env:		resd 1
.info:		resd 1
.size:		resd 1
.module:	resd 1
[absolute 0]
info:
.type:		resd 1	;1 for BMP, 2 for JPEG
		resd 1	;0
.width:		resd 1
.height:	resd 1
[section .text]
[global  _info_BMP]
_info_BMP:
	push ebx
	push ebp
	push esi
	push edi
	mov esi, [esp+bmpinfo.module]
	mov eax, [esp+bmpinfo.size]
	call bmpHeader			;esi=0 for error
	test esi, esi
	jz .ret
	test ecx, ecx
	jns .bottomup
	neg ecx
.bottomup:
	mov ebx, [esp+bmpinfo.info]
	mov [ebx+info.width], eax
	xor eax, eax
	mov [ebx+info.height], ecx
	mov [ebx+info.type+4], eax	;=0
	inc eax
	mov [ebx+info.type], eax	;=1
.ret:	mov eax, esi
	pop edi
	pop esi
	pop ebp
	pop ebx
	ret

;in: esi=module, eax=size
;ret:eax=width, ecx=hegiht(ˤʤ), edx=paletteSize, ebx=palette
;    ebp=bpp, esi=endOfImage, edi=successFlag
bmpHeader:
	lea edx, [esi+eax]		;moduleEnd
	xor edi, edi
	push edx
	xor edx, edx

	cmp eax, byte BMP.iSize+4
	jbe ..@ret			;ѤƤޤ
	cmp word[esi],'BM'
	je .notMAC
	sub esi, byte -128
	add eax, byte -128
	pop ebx
	push eax
	cmp eax, byte BMP.iSize+4
..@ret:	jbe near .err
	cmp word[esi], 'BM'
	jne near .err
.notMAC:
	;;MS,OS/2 եޥåȳǧ
	mov ecx, [esi +BMP.iSize]
	cmp ecx, byte 12			;OS/2 format.
	jne .MS
	  cmp eax, byte BMPOS2_size
	  jbe near .err				;coreإåʤ
	  lea ebx, [esi+ecx+14]			;palette
	  movzx eax, word[esi+BMPOS2.iWidth]	;width
	  movsx ecx, word[esi+BMPOS2.iHeight]	;height
	  movzx ebp, word[esi+BMPOS2.iBitCount]	;bpp
	  mov dl, 3				;paletteSize
	jmp short .endif
.MS:	  cmp eax, byte BMP_size
	  jbe .err				;infoإåʤ
	  lea ebx, [esi+ecx+14]			;palette
	  sub ecx,byte 40
	  jne .err				;unknownFormat
	  mov eax, [esi+BMP.iCompression]
	  cmp eax, byte 3			;16/32bpp
	  je .bmpv3
	  test eax, eax
	  jnz .err				;Compressed.
.bmpv3:	  mov dh, al				;compressionType
	  mov eax, [esi+BMP.iWidth]		;width
	  mov ecx, [esi+BMP.iHeight]		;height
	  movzx ebp, word[esi +BMP.iBitCount]	;bpp
	  mov dl, 4				;paletteSize
.endif:
	;ºݤΥե뤬Ǥheightä
	;ɤ٤ϥ顼
	push edx
	push eax
	mul ebp				;eax=width*bpp

	;fOffBits=0ΤȤΥǥեͤ׻
	;ñ˥ѥåȤμʤ
	mov edx, [esi+BMP.fOffBits]
	test edx, edx
	jnz .notdefault
	cmp ebp, byte 8			;bpp, compress򸵤˥ǥեͷ
	ja .notIndexColor
	  movzx edx, byte[esp+4]	;pushed paletteSize
	  push ecx
	  mov ecx, ebp
	  shl edx, cl
	  pop ecx
.notIndexColor:
	  cmp byte[esp+5], 3		;indexColor3Ϥꤨʤ
	  jne .endPalette
	  add edx, byte 12		;bitFieldMask礭	  
.endPalette:
	sub edx, esi			;ebxpaletteΥݥ
	add edx, ebx			;edx=defaultfOffBits
.notdefault:
	add esi, edx

	add eax, byte 7
	shr eax, 3			;lineSizeWithoutPudding
	mov edx, eax
	add eax, byte 3			;size<1GBꤷedx̵
	and al, -4			;lineSizeWithPudding
	mov edi, esi
	sub edx, eax			;=-paddingSize
	sub edi, eax			;ǽιԤι
	imul eax, ecx
	jnc .bottomup			;32bitؤcarry
	neg eax				;礭ˤ뤬heightΤޤ
.bottomup:
	add esi, eax
	add esi, edx			;ǽԤκǸˤpaddingʤcheck
	cmp esi, [esp+8]		;endOfModule
	pop eax
	jna .ret2			;succeeded
	mov esi, edx			;esi=0 for error
.ret2:	sub esi, edx			;esi=endOfImage
	pop edx
.ret:	add esp, byte 4
	ret
.err:	xor esi, esi
	jmp short .ret

;***************************************************************
; ͥǺäƤ뤬, ®ͥǺäΤΤꤤ⡣
; ʼι®⡼ɤΤߺäƤ

[absolute -4*10]
decode:
.buffer:	resd 1
.destbuf:	resd 1
.sw:		resd 1	;source line width in byte
.paletteSize:	resb 1
.compress:	resb 1
		resb 2
.x:		resd 1
.w:		resd 1	;line width in pixel to transfer
.h:		resd 1
.s:		resd 1	;skip
.t:		resd 1	;bufferType
.bpp:		resd 1
.regs:		resd 4	;0
.reteip:	resd 1
.env:		resd 1
.size:		resd 1
.module:	resd 1
.outputType:	resd 1
.dest:		resd 1
.skip:		resd 1
[section .text]
[global _decode0_BMP]
_decode0_BMP:
	push ebx
	push ebp
	push esi
	push edi
	mov esi, [esp+decode.module]
	mov eax, [esp+decode.size]
	call bmpHeader
	;ret:eax=width, ecx=hegiht, edx=paletteSize, ebx=palette
	;    ebp=bpp, esi=endOfImage (0 for error), edi=prevLineOfFirstLine
	push ebp
	lea ebp, [esp+4]
	
	test byte[ebp+decode.outputType], 4	;32bpp
	jnz .noGosakaku
	cmp eax, (65536-32)/8
	ja .error			;Хåե­ʤ
.noGosakaku:
	test esi,esi
	jz .error
	push dword[ebp+decode.outputType] ;>>t
	push dword[ebp+decode.skip]	;>>s
	push ecx			;>>h
	push eax			;>>w
	push byte 0			;>>x0
	push edx			;>>comp:paletteSize
	mul dword[ebp+decode.bpp]
	add eax, byte 31
	shr eax, 3
	and al, -4
	test ecx,ecx
	jns .bottomup
	neg ecx
	mov [ebp+decode.h], ecx		;height
	mov esi, edi
	neg eax				;sw
.bottomup:
	push eax			;>>sw
	push eax			;>>dest buf
	mov eax, [ebp+decode.env]
	add eax, byte 32		;Ƭ32ХȤϵǽޤäƤ
	mov edx, ebp			;bpp
	push eax			;>>buffer
	mov ecx, [ebp+decode.w]		;width
	lea edi, [eax+ecx*4]		;Хåե
	xor eax, eax
	rep stosd
	mov ecx, [ebp+decode.h]		;height
	mov edx, [ebp+decode.bpp]
	mov edi, [ebp+decode.dest]
	mov ebp, esp
	call bmp2beta			;ecx!=0 for error
	lea ebp, [esp-decode]
	mov eax, ecx
	test ecx, ecx
	jz .ret
.error:	push byte 1
	pop eax
.ret:	mov esp, ebp
	pop edi
	pop esi
	pop ebp
	pop ebx
	ret

[absolute -4*10]
part:
.buffer:	resd 1	;struct bb {
.destbuf:	resd 1
.sw:		resd 1	;byte unit
.paletteSize:	resb 1
.compress:	resb 1
		resb 2
.x:		resd 1
.w:		resd 1	;pixel unit
.h:		resd 1
.s:		resd 1
.t:		resd 1	;}
.bpp:		resd 1
.regs:		resd 4	;+0
.reteip:	resd 1
.env:		resd 1
.xsz:		resd 1
.ysz:		resd 1
.x0:		resd 1
.y0:		resd 1
.size:		resd 1
.module:	resd 1
.outputType:	resd 1
.dest:		resd 1
.skip:		resd 1
[section .text]
[global _decode0_BMPpart]
_decode0_BMPpart:		;decode0_BMPΥԥ+
	push ebx
	push ebp
	push esi
	push edi
	mov esi, [esp+part.module]
	mov eax, [esp+part.size]
	call bmpHeader
	;ret:eax=width, ecx=hegiht, edx=paletteSize, ebx=palette
	;    ebp=bpp, esi=endOfImage (0 for error), edi=prevLineOfFirstLine
	push ebp			;bpp
	lea ebp, [esp+4]		;struct part
	push dword[ebp+part.outputType] ;>>t
	push dword[ebp+part.skip]	;>>s
	push ecx			;>>h
	mov ecx, [ebp+part.x0]
	push dword[ebp+part.xsz]	;>>w
	push ecx			;>>x
	push edx			;>>comp:paletteSize
	add ecx, [ebp+part.xsz]
	jc .error			;x0+xsz32bitĶ
	cmp ecx, eax
	ja .error			;x0+xsz > w
	test byte[ebp+part.outputType], 4 ;32bpp
	jnz .noGosakaku
	cmp eax, (65536-32)/8
	ja .error			;Хåե­ʤ
.noGosakaku:
	test esi,esi
	jz .error
	mul dword[ebp+part.bpp]
	add eax, byte 31
	shr eax, 3
	mov ecx, [ebp+part.h]
	and al, -4
	test ecx,ecx
	jns .bottomup
	neg ecx				;h
	neg eax				;sw
	mov [ebp+part.h], ecx
	mov esi, edi
.bottomup:
	mov ecx, [ebp+part.y0]
	add ecx, [ebp+part.ysz]
	jc .error			;y0+ysz32bitĶ
	cmp ecx, [ebp+part.h]
	ja .error			;y0+ysz > h

	push eax			;>>sw
	push eax			;>>dest (dummy push)
	imul eax, [ebp+part.y0]
	sub esi, eax
	mov eax, [ebp+part.env]
	add eax, byte 32		;Ƭ32ХȤϵǽޤäƤ
	push eax			;>>buffer
	mov ecx, [ebp+part.xsz]		;Ÿ
	lea edi, [eax+ecx*4]		;Хåե
	xor eax, eax
	rep stosd			;
	mov ecx, [ebp+part.ysz]
	mov edx, [ebp+part.bpp]
	mov edi, [ebp+part.dest]
	mov ebp, esp			;struct bb
	call bmp2beta			;ecx!=0 for error
	lea ebp, [esp-part]
	mov eax, ecx
	test ecx, ecx
	jz .ret
.error:	push byte 1
	pop eax
.ret:	mov esp, ebp
	pop edi
	pop esi
	pop ebp
	pop ebx
	ret

[absolute -4*4]
bb:
.col0:		resd 1	;bpp1ǻȤ
.pre:		resd 1	;pre line call
.post:		resd 1	;post line call
.reteip:	resd 1
.buffer:	resd 1
.dest:		resd 1
.sw:		resd 1	;source line width in byte
.paletteSize:	resb 1
.compress:	resb 1
		resb 2
.x:		resd 1
.w:		resd 1	;line width in pixel to transfer
.h:		resd 1
.s:		resd 1	;skip
.t:		resd 1	;bufferType
.size: equ $-$$

[section .text]
;eax=?, ecx=height, edx=bpp, ebx=palette
;ebp=bb, esi=endOfImage/prevOfFirstLine, edi=dest

;Ȼ:
;ϤΤޤѹʤ
;ǥƥ͡ϸȻʤ饤ƬǺؤ
;(to32ʳenvΰȤ, to32̵),
;饤νǸʤ᤹, Ȥˤʤ롣
;Ĥޤ, 饤Ƭpush, ֥롼Ǻؤ,
;饤üǤ"֥롼"loadϤȤȡ
;pushediλϸƤӽФ¦Ǥ롣뤤push
;äѤʤǤ͡

pre:
.to3:
.to4:
.to6:
.to16:	mov [ebp+bb.dest], edi
	mov edi, [ebp+bb.buffer]
.to32:	ret

;eax,ecx,edx,ebx,esi˲, ediϼline (skip­),
;ecx=count, ebx=[errorFromUp], esi=[source](32bit), edi=[dest](16bit)
post:
.to3:	push ebp
	mov ebx, edi			;ϥХåեμ˸Хåե
	mov ecx, [ebp+bb.w]
	mov esi, [ebp+bb.buffer]
	mov edi, [ebp+bb.dest]
	xor ebp, ebp			;ηۤ
	call _to3
	pop ebp
	jmp short .ret

.to4:	push ebp
	mov ebx, edi
	mov ecx, [ebp+bb.w]
	mov esi, [ebp+bb.buffer]
	mov edi, [ebp+bb.dest]
	xor ebp, ebp
	call _to4
	pop ebp
	jmp short .ret

.to6:	push ebp
	mov ebx, edi
	mov ecx, [ebp+bb.w]
	mov esi, [ebp+bb.buffer]
	mov edi, [ebp+bb.dest]
	xor ebp, ebp			;ηۤ
	call _to6
	pop ebp
	jmp short .ret

.to16:	push ebp
	mov ebx, edi
	mov ecx, [ebp+bb.w]
	mov esi, [ebp+bb.buffer]
	mov edi, [ebp+bb.dest]
	xor ebp, ebp			;ηۤ
	call _to16
	pop ebp
.to32:
.ret:
	add edi, [ebp+bb.s]
	ret

bmp2beta:
	mov eax, [ebp+bb.t]
	cmp al, 1
	je .buf8
	cmp al, 2
	je .buf16
	cmp al, 4
	je .buf32
	mov ecx, esp		;!=0
	ret

.buf8:	and ah, 0x7f		;MSBϹ®/ʼե饰, ̵
	cmp ah, 8
	jne .4
	push dword post.to6	;6bit
	push dword pre.to6
	jmp short .decode
.4:	cmp ah, 2
	jne .2
	push dword post.to4
	push dword pre.to4
	jmp short .decode	;4bit
.2:	push dword post.to3
	push dword pre.to3
	jmp short .decode
.buf16:	push dword post.to16
	push dword pre.to16
	jmp short .decode
.buf32:	push dword post.to32
	push dword pre.to32
.decode:
	dec edx
	je near .bpp1
	sub edx, byte 4-1
	je near .bpp4
	sub edx, byte 8-4
	je near .bpp8
	sub edx, byte 16-8
	je near .bpp16
	sub edx, byte 24-16
	je near .bpp24
	sub edx, byte 32-24
	je .bpp32
	mov ecx, esp		;!=0
	ret
;---------------------------------------------------
;	32bpp BMP to 4byte bufer
;---------------------------------------------------
.bpp32:
	;ecx=height, edx=0, ebx=palette (Rmask, Gmask, Bmask, RGB shifts)
	;esi=endOfImage, edi=destinationBuffer
	;bb.w=width(pixel), bb.s=skipByte, (bb.h=height)
	;bb.t=outputType, bb.sw=sourceWidthByte

	cmp byte[ebp+bb.compress], 3
	push ecx
	jne .noCompress32

	mov eax, [ebx]		;R mask
	bsf edx, eax		;ecx-edx+1=bitFieldLength
	bsr ecx, eax		;eax=0ΤȤedx=undefʤ
	mov ch, 1
	sub ch, dl
	mov edx, 0xff000000
	add ch, cl
	xor cl, byte 31
	shr edx, cl
	push eax		;>>shifts dummy
	push ecx		;>>shifts
	and eax, edx
	push eax		;>>R mask

	mov eax, [ebx+4]	;G mask
	bsf edx, eax
	bsr ecx, eax
	mov ch, 1
	sub ch, dl
	mov edx, 0xff000000
	add ch, cl
	xor cl, byte 31
	shr edx, cl
	mov [esp+4+2], cx	;G shift
	and eax, edx
	push eax		;>>G mask

	mov eax, [ebx+8]	;B mask
	bsf edx, eax
	bsr ecx, eax
	mov ch, 1
	sub ch, dl
	mov edx, 0xff000000
	add ch, cl
	xor cl, byte 31
	shr edx, cl
	mov [esp+12], cx	;B shift
	and eax, edx
	push eax		;>>B mask

	mov ecx, [esp+4*5]
	jmp short .bitFieldDone32
.noCompress32:
	push dword 0x00000818
	push dword 0x08100808
	push dword 0x00ff0000	;R mask
	push dword 0x0000ff00	;G mask
	push dword 0x000000ff	;B mask
.bitFieldDone32:

	.do32.1:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=startOfLine
	  mov eax, [ebp+bb.x]
	  push ecx
	  push esi
	  lea esi, [esi+eax*4]
	  mov ebx, [ebp+bb.w]
	  push ebp
	  .do32.2:
	    mov ebp, [esi]	;source data

	    mov eax, [esp+12+8]	;R mask
	    mov cl, [esp+12+12] ;R shift
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+1] ;R length
	    shr eax, 8		;Ǿ̤8bit
	    mov edx, eax
	    shr eax, cl
	    and eax, 0x00ff0000
	    or edx, eax

	    mov eax, [esp+12+4] ;G mask
	    mov cl, [esp+12+12+2] ;G shift
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+3] ;G length
	    shr eax, 16
	    or edx, eax
	    shr eax, cl
	    and eax, 0x0000ff00
	    or edx, eax

	    mov eax, [esp+12]	;B mask
	    mov cl, [esp+12+12+4] ;B shift
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+5] ;B length
	    shr eax, 24
	    or edx, eax
	    shr eax, cl
	    or edx, eax

	    add esi, byte 4
	    mov [edi], edx
	    add edi, byte 4
	    dec ebx
	  jnz .do32.2
	  pop ebp
	  call [ebp+bb.post]
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do32.1
	add esp, byte 4*8
	ret

;---------------------------------------------------
;	24bpp BMP to 4byte bufer
;---------------------------------------------------
.bpp24:
	;ecx=height, edx=0, ebx=palette
	;esi=endOfImage, edi=destinationBuffer
	;bb.w=width(pixel), bb.s=skipByte, (bb.h=height)
	;bb.t=outputType, bb.sw=sourceWidthByte

	.do24.1:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=startOfLine
	  mov eax, [ebp+bb.x]
	  xor edx, edx
	  lea eax, [eax*3]
	  push ecx
	  push esi
	  add esi, eax
	  mov ecx, [ebp+bb.w]
	  .do24.2:
	    mov al, [esi]
	     mov [edi+3], dl
	    mov [edi], al
	     mov al, [esi+1]
	    mov [edi+1], al
	     mov al, [esi+2]
	    mov [edi+2], al
	     add esi, byte 3
	    add edi, byte 4
	     dec ecx
	  jnz .do24.2
	  call [ebp+bb.post]
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do24.1
	add esp, byte 4*2
	ret

;---------------------------------------------------
;	16bpp BMP to 4byte bufer
;---------------------------------------------------
.bpp16:
	;ecx=height, edx=0, ebx=palette (Rmask, Gmask, Bmask, RGB shifts)
	;esi=endOfImage, edi=destinationBuffer
	;bb.w=width(pixel), bb.s=skipByte, (bb.h=height)
	;bb.t=outputType, bb.sw=sourceWidthByte

	cmp byte[ebp+bb.compress], 3
	push ecx
	jne .noCompress16

	movzx eax, word[ebx]	;R mask
	bsf edx, eax
	bsr ecx, eax		;eax=0ΤȤedx=undefʤ
	mov ch, 1
	sub ch, dl
	mov edx, 0x0000ff00
	add ch, cl
	xor cl, 15		;150, 141,..., 015
	shr edx, cl
	add cl, 8
	and eax, edx
	push edx		;>>shifts dummy
	push ecx		;>>shifts
	push eax		;>>R mask

	movzx eax, word[ebx+4]	;G mask
	bsf edx, eax
	bsr ecx, eax
	mov ch, 1
	sub ch, dl
	mov edx, 0x0000ff00
	add ch, cl
	xor cl, 15		;150, 141,..., 015
	shr edx, cl
	add cl, 8
	and eax, edx
	mov [esp+4+2], cx	;G shifts
	push eax		;>>G mask

	movzx eax, word[ebx+8]	;B mask
	bsf edx, eax
	bsr ecx, eax
	mov ch, 1
	sub ch, dl
	mov edx, 0x0000ff00
	add ch, cl
	xor cl, 15		;150, 141,..., 015
	shr edx, cl
	add cl, 8
	and eax, edx
	mov [esp+8+4], cx	;B shift
	push eax		;>>B mask

	mov ecx, [esp+4*5]
	jmp short .bitFieldDone16

.noCompress16:
	push dword 0x00000513
	push dword 0x050e0509
	push dword 0x00007c00	;R mask
	push dword 0x000003e0	;G mask
	push byte        0x1f	;B mask
.bitFieldDone16:

	.do16.1:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=startOfLine
	  mov eax, [ebp+bb.x]
	  push ecx
	  push esi
	  lea esi, [esi+eax*2]
	  mov ebx, [ebp+bb.w]
	  push ebp
	  .do16.2:
	    movzx ebp, word[esi]

	    mov eax, [esp+12+8]	;R mask
	    mov cl, [esp+12+12+0] ;R shifts
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+1] ;R length
	    mov edx, eax
	    shr eax, cl
	    and eax, 0x00ff0000
	    or edx, eax

	    mov eax, [esp+12+4]	;G mask
	    mov cl, [esp+12+12+2] ;G shifts
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+3] ;G length
	    shr eax, 8
	    or edx, eax
	    shr eax, cl
	    and eax, 0x0000ff00
	    or edx, eax

	    mov eax, [esp+12+0]	;B mask
	    mov cl, [esp+12+12+4] ;B shifts
	    and eax, ebp
	    shl eax, cl
	    mov cl, [esp+12+12+5] ;B length
	    shr eax, 16
	    or edx, eax
	    shr eax, cl
	    and eax, 0x000000ff
	    or edx, eax

	    add esi, byte 2
	    mov [edi], edx
	    add edi, byte 4
	    dec ebx
	  jnz .do16.2
	  pop ebp
	  call [ebp+bb.post]
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do16.1
	add esp, byte 4*8
	ret

;---------------------------------------------------
;	8bpp BMP to 4byte buffer
;---------------------------------------------------
.bpp8:
	;ecx=height, edx=0, ebx=palette
	;esi=endOfImage, edi=destinationBuffer

	;palleteѴ
	mov eax, [ebp+bb.paletteSize]
	mov dl, 255
	test ah, ah
	jnz .ret8		;RLEб
	sub ebx, eax
	shl eax, 8
	add ebx, eax		;ebx += paletteSize*255
	.do8.1:
	  mov eax, [ebx]
	  sub ebx, [ebp+bb.paletteSize]
	  and eax, 0x00ffffff
	  dec edx
	  push eax
	jns .do8.1

	.do8.2:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=firstLineStart
	  push ecx
	  push esi
	  add esi, [ebp+bb.x]
	  mov ecx, [ebp+bb.w]
	  .do8.3:
	    xor eax, eax
	     add edi, byte 4
	    mov al, [esi]
	     inc esi
	    ;AGI stole
	    mov eax, [esp+eax*4+8]
	     dec ecx
	    mov [edi-4], eax
	  jnz .do8.3
	  call [ebp+bb.post]
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do8.2
	add esp, 258*4		;palette, post, pre
.ret8:	ret

;---------------------------------------------------
;	4bpp BMP to 4byte buffer
;---------------------------------------------------
.bpp4:
	;ecx=height, edx=0, ebx=palette
	;esi=endOfImage, edi=destinationBuffer

	;palleteѴ
	mov eax, [ebp+bb.paletteSize]
	mov dl, 16
	test ah, ah
	jnz .ret4			;RLEб
	sub ebx, eax
	shl eax, 4
	add ebx, eax			;ebx+=eax*15
	.do4.1
	  mov eax, [ebx]
	  sub ebx, [ebp+bb.paletteSize]
	  and eax, 0x00ffffff
	  dec edx
	  push eax
	jnz .do4.1

	.do4.2:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=firstLineStart
	  mov eax, [ebp+bb.x]
	  shr eax, 1
	  push ecx
	  push esi
	  mov ecx, [ebp+bb.w]
	  lea esi, [esi+eax]
	  jnc .do4.3		;ԤκǽȾüʥԥ
	    mov al, [esi]
	    inc esi
	    and eax, byte 0x0f
	    mov eax, [esp+eax*4+8]
	    mov [edi], eax
	    add edi, byte 4
	    dec ecx
	    jz .wend
	  .do4.3:
	    xor edx, edx
	     mov al, [esi]
	    mov dl, al
	     inc esi
	    shr dl, 4
	     and eax, byte 15
	    add edi, byte 4
	     dec ecx
	    mov edx, [esp+edx*4+8]
	     mov eax, [esp+eax*4+8]
	    mov [edi-4], edx
	     jz .wend
	    mov [edi], eax
	     add edi, byte 4
	    dec ecx
	  jnz .do4.3
.wend:	  call [ebp+bb.post]
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do4.2
	add esp, 18*4		;palette, post, pre
.ret4:	ret

;---------------------------------------------------
;	1bpp BMP to 4byte buffer
;---------------------------------------------------
.bpp1:
	;ecx=height, edx=0, ebx=palette
	;esi=endOfImage, edi=destinationBuffer

	;palleteѴ
	mov eax, [ebx]
	add ebx, [ebp+bb.paletteSize]
	and eax, 0x00ffffff
	mov ebx, [ebx]
	and ebx, 0x00ffffff
	xor ebx, eax
	;push ebx
	push eax

	.do1.1:
	  call [ebp+bb.pre]
	  sub esi, [ebp+bb.sw]	;esi=firstLineStart
	  mov eax, [ebp+bb.x]
	  push ecx
	  mov cl, al
	  shr eax, 3
	  push esi
	  add esi, eax
	  mov eax, 8
	  and ecx, byte 0x07
	  jz .even
	    mov dl, [esi]
	    inc esi
	    shl dl, cl
	    sub eax, ecx
	    mov ecx, [ebp+bb.w]
	    jmp short .odd
.even:
	  mov ecx, [ebp+bb.w]
	  .do1.2:
	    mov dl, [esi]
	     inc esi
.odd:	    push esi
	     mov esi, eax
	    .do1.3:
	      add edi, byte 4
	       add dl, dl
	      sbb eax, eax
	      and eax, ebx
	      xor eax, [ebp+bb.col0]
	       dec ecx
	      mov [edi-4], eax
	       jz .wend1bpp
	      dec esi
	    jnz .do1.3
	    lea eax, [esi+8]
	    pop esi
	  jmp short .do1.2
.wend1bpp:pop esi		;pop esiФƤΤǤ
	  push ebx
	  call [ebp+bb.post]
	  pop ebx
	  pop esi
	  pop ecx
	  dec ecx
	jnz .do1.1
	add esp, byte 4*3	;diff, post, pre
	ret
