/*** pngpic.c png decode part for picture0 */

#include <guigui00.h>
#include "png.h"
#include "gosakaku.h"
#define NULL ((void*)0)

/** [U^64KB̊ */
#define WORKSIZE (65536 - 32 - ((sizeof(Png)+3) & ~3))
typedef struct PNG_ENV {
  char reserved[32];
  char work[WORKSIZE];
  Png png[1];
} ENV, *ENV_t;

/** J֐̐錾 */
int info_PNG(ENV_t env, int *info, int size, byte *fp0);
int decode0_PNG(ENV_t env, int size, byte *fp0, int b_type, byte *buf, int skip);
int decode0_PNGpart(ENV_t env, int xsz, int ysz, int x0, int y0,int size, byte *fp0, int b_type, byte *buf, int skip);

/** J֐` */
int info_PNG(ENV_t env, int *info, int size, byte *fp0)
{
  if (Png_parse(env->png, &fp0, fp0 + size)) /* ꉞfpi߂Ă */
    return 0;

  info[0] = 0x0003;		/* type */
  info[1] = 0;
  info[2] = Png_getWidth(env->png);
  info[3] = Png_getHeight(env->png);
  return 1;
}

int decode0_PNG(ENV_t env, int size, byte *fp0, int b_type, byte *buf, int skip)
{
  Gosakaku_t gosakaku = NULL;
  int width = Png_getWidth(env->png);

  b_type &= 0x0b07;
  if ((b_type & 0x07) == 2)
    gosakaku = gosakaku16;
  else if ((b_type & 0x07) == 1) {
    if ((b_type & 0x0b00) == 0x0800)
      gosakaku = gosakaku6;
    else if ((b_type & 0x0b00) == 0x0200)
      gosakaku = gosakaku4;
    else if ((b_type & 0x0b00) == 0x0100)
      gosakaku = gosakaku3;
    else
      goto errorBtype;
  } else if ((b_type & 0x07) != 4) {
  errorBtype:
    return 2;			/* p[^G[ */
  }
  return
    Png_parse(env->png, &fp0, fp0 + size) ? 3 :
    Png_memallocate(env->png, env->work, WORKSIZE, buf, gosakaku) ? 4 :
    Png_decode(env->png, skip + width * (b_type & 7)) ? 5 :
    0;				/* ȕ@Ă݂ */
}

int decode0_PNGpart(ENV_t env, int xsz, int ysz, int x0, int y0,int size, byte *fp0, int b_type, byte *buf, int skip)
{
  return 1;			/*  */
}
